3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] <mbox>...
7 or, when resuming [--skip | --resolved]'
12 git var GIT_COMMITTER_IDENT >/dev/null || exit
15 echo "$1" >"$dotest/next"
19 stop_here_user_resolve () {
20 if [ -n "$resolvemsg" ]; then
24 cmdline=$(basename $0)
25 if test '' != "$interactive"
29 if test '' != "$threeway"
33 if test '.dotest' != "$dotest"
35 cmdline="$cmdline -d=$dotest"
37 echo "When you have resolved this problem run \"$cmdline --resolved\"."
38 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
44 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45 "$dotest/patch" "$dotest/info"
46 echo "$next" >"$dotest/next"
52 echo "Cannot fall back to three-way merge."
57 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
59 rm -fr "$dotest"/patch-merge-*
60 mkdir "$dotest/patch-merge-tmp-dir"
62 # First see if the patch records the index info that we can use.
63 git-apply -z --index-info "$dotest/patch" \
64 >"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68 git-write-tree >"$dotest/patch-merge-base+" ||
69 cannot_fallback "Patch does not record usable index information."
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73 git-apply $binary --cached <"$dotest/patch"
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
78 cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
82 test -f "$dotest/patch-merge-index" &&
83 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
84 orig_tree=$(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-* || exit 1
87 echo Falling back to patching base and 3-way merge...
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
92 # patch did not touch, so recursive ends up canceling them,
93 # saying that we reverted all those changes.
95 eval GITHEAD_$his_tree='"$SUBJECT"'
96 export GITHEAD_$his_tree
97 git-merge-recursive $orig_tree -- HEAD $his_tree || {
98 if test -d "$GIT_DIR/rr-cache"
102 echo Failed to merge in the changes.
105 unset GITHEAD_$his_tree
109 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary= ws= resolvemsg=
111 while case "$#" in 0) break;; esac
114 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
115 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
116 -d|--d|--do|--dot|--dote|--dotes|--dotest)
117 case "$#" in 1) usage ;; esac; shift
120 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
121 --interacti|--interactiv|--interactive)
122 interactive=t; shift ;;
124 -b|--b|--bi|--bin|--bina|--binar|--binary)
127 -3|--3|--3w|--3wa|--3way)
129 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
131 -u|--u|--ut|--utf|--utf8)
132 utf8=t; shift ;; # this is now default
133 --no-u|--no-ut|--no-utf|--no-utf8)
135 -k|--k|--ke|--kee|--keep)
138 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
148 resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
159 # If the dotest directory exists, but we have finished applying all the
160 # patches in them, clear it out.
161 if test -d "$dotest" &&
162 last=$(cat "$dotest/last") &&
163 next=$(cat "$dotest/next") &&
165 test "$next" -gt "$last"
172 case "$#,$skip$resolved" in
174 # Explicit resume command and we do not have file, so
178 # No file input but without resume parameters; catch
179 # user error to feed us a patch from standard input
180 # when there is already .dotest. This is somewhat
181 # unreliable -- stdin could be /dev/null for example
182 # and the caller did not intend to feed us a patch but
183 # wanted to continue unattended.
190 die "previous dotest directory $dotest still exists but mbox given."
193 # Make sure we are not given --skip nor --resolved
194 test ",$skip,$resolved," = ,,, ||
195 die "Resolve operation not in progress, we are not resuming."
198 mkdir -p "$dotest" || exit
200 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
205 # -b, -s, -u, -k and --whitespace flags are kept for the
206 # resuming session after a patch failure.
207 # -3 and -i can and must be given when resuming.
208 echo "$binary" >"$dotest/binary"
209 echo " $ws" >"$dotest/whitespace"
210 echo "$sign" >"$dotest/sign"
211 echo "$utf8" >"$dotest/utf8"
212 echo "$keep" >"$dotest/keep"
213 echo 1 >"$dotest/next"
218 files=$(git-diff-index --cached --name-only HEAD) || exit
219 if [ "$files" ]; then
220 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
225 if test "$(cat "$dotest/binary")" = t
227 binary=--allow-binary-replacement
229 if test "$(cat "$dotest/utf8")" = t
235 if test "$(cat "$dotest/keep")" = t
239 ws=`cat "$dotest/whitespace"`
240 if test "$(cat "$dotest/sign")" = t
242 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
244 s/^/Signed-off-by: /'
250 last=`cat "$dotest/last"`
251 this=`cat "$dotest/next"`
254 if test -d "$GIT_DIR/rr-cache"
258 this=`expr "$this" + 1`
262 if test "$this" -gt "$last"
269 while test "$this" -le "$last"
271 msgnum=`printf "%0${prec}d" $this`
272 next=`expr "$this" + 1`
273 test -f "$dotest/$msgnum" || {
279 # If we are not resuming, parse and extract the patch information
280 # into separate files:
281 # - info records the authorship and title
282 # - msg is the rest of commit log message
283 # - patch is the patch body.
285 # When we are resuming, these files are either already prepared
286 # by the user, or the user can tell us to do so by --resolved flag.
289 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
290 <"$dotest/$msgnum" >"$dotest/info" ||
292 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
296 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
297 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
298 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
300 if test -z "$GIT_AUTHOR_EMAIL"
302 echo "Patch does not have a valid e-mail address."
306 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
308 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
309 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
313 if test '' != "$SIGNOFF"
316 sed -ne '/^Signed-off-by: /p' \
317 "$dotest/msg-clean" |
321 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
322 test '' = "$LAST_SIGNED_OFF_BY" && echo
330 if test -s "$dotest/msg-clean"
333 cat "$dotest/msg-clean"
335 if test '' != "$ADD_SIGNOFF"
339 } >"$dotest/final-commit"
342 case "$resolved$interactive" in
344 # This is used only for interactive view option.
345 git-diff-index -p --cached HEAD >"$dotest/patch"
351 if test "$interactive" = t
354 die "cannot be interactive without stdin connected to a terminal."
356 while test "$action" = again
358 echo "Commit Body is:"
359 echo "--------------------------"
360 cat "$dotest/final-commit"
361 echo "--------------------------"
362 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
366 [aA]*) action=yes interactive= ;;
367 [nN]*) action=skip ;;
368 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
371 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
379 if test $action = skip
385 if test -x "$GIT_DIR"/hooks/applypatch-msg
387 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
392 echo "Applying '$SUBJECT'"
397 git-apply $binary --index $ws "$dotest/patch"
401 # Resolved means the user did all the hard work, and
402 # we do not have to do any patch application. Just
403 # trust what the user has in the index file and the
406 changed="$(git-diff-index --cached --name-only HEAD)"
407 if test '' = "$changed"
409 echo "No changes - did you forget to use 'git add'?"
410 stop_here_user_resolve $this
412 unmerged=$(git-ls-files -u)
413 if test -n "$unmerged"
415 echo "You still have unmerged paths in your index"
416 echo "did you forget to use 'git add'?"
417 stop_here_user_resolve $this
420 if test -d "$GIT_DIR/rr-cache"
427 if test $apply_status = 1 && test "$threeway" = t
431 # Applying the patch to an earlier tree and merging the
432 # result may have produced the same tree as ours.
433 changed="$(git-diff-index --cached --name-only HEAD)"
434 if test '' = "$changed"
436 echo No changes -- Patch already applied.
440 # clear apply_status -- we have successfully merged.
444 if test $apply_status != 0
446 echo Patch failed at $msgnum.
447 stop_here_user_resolve $this
450 if test -x "$GIT_DIR"/hooks/pre-applypatch
452 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
455 tree=$(git-write-tree) &&
456 echo Wrote tree $tree &&
457 parent=$(git-rev-parse --verify HEAD) &&
458 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
459 echo Committed: $commit &&
460 git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
463 if test -x "$GIT_DIR"/hooks/post-applypatch
465 "$GIT_DIR"/hooks/post-applypatch